#!/usr/bin/python -u
import sys
import os
from malib import *

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

alus = int(sys.argv[2])
mults = int(sys.argv[3])
registers = int(sys.argv[4])

print os.times()

class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.a0 = COp1(self,0)
		self.m1 = COp2p(self,0)
		self.m2 = COp2p(self,0)
		self.a3 = COp1(self,0)
		self.m4 = COp2p(self,0)
		self.a5 = COp1(self,0)
		self.m6 = COp2p(self,0)
		self.a7 = COp1(self,0)

		self.outtags = [self.a7, ]

                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		IEnable(set,self.a0.known[0],self.a0.required[0])
		IEnable(set,self.a5.known[0],self.a5.required[1])
		IEnable(set,self.a7.known[0],self.a7.required[0])
		Enable(set,self.m2.known[0],self.a3.required[0])
		Enable(set,self.a3.known[0],self.m4.required[0])
		Enable(set,self.m4.known[0],self.a5.required[0])
		IEnable(set,self.a5.known[0],self.m6.required[0])
		Enable(set,self.m6.known[0],self.a7.required[1])
		IEnable(set,self.a0.known[0],self.m2.required[0])
		IEnable(set,self.a5.known[0],self.m2.required[1])
		IEnable(set,self.a7.known[0],self.a3.required[1])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		ICapacity(set,self.a0.known[0],self.a0.accepted[0])
		ICapacity(set,self.a5.known[0],self.a5.accepted[1])
		ICapacity(set,self.a7.known[0],self.a7.accepted[0])
		Capacity(set,self.m2.known[0],self.a3.accepted[0])
		Capacity(set,self.a3.known[0],self.m4.accepted[0])
		Capacity(set,self.m4.known[0],self.a5.accepted[0])
		ICapacity(set,self.a5.known[0],self.m6.accepted[0])
		Capacity(set,self.m6.known[0],self.a7.accepted[1])
		ICapacity(set,self.a0.known[0],self.m2.accepted[0])
		ICapacity(set,self.a5.known[0],self.m2.accepted[1])
		ICapacity(set,self.a7.known[0],self.a3.accepted[1])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()


	def BuildGroups(self):

		self.alu_res = Group(0, alus, (self.a0.busy[0], self.a3.busy[0], self.a5.busy[0], self.a7.busy[0]))
		self.TR.PruneT(self.alu_res.BuildActive(),(0,1))

		self.mult_res = Group(0, mults, (self.m1.busy[0], self.m2.busy[0], self.m4.busy[0], self.m6.busy[0]))
		self.TR.PruneT(self.mult_res.BuildActive(),(0,1))

	def BuildMemory(self):
		self.a0.BuildIMemory(0,self.a0.accepted[0])
		self.a5.BuildIMemory(0,self.a5.accepted[1])
		self.a7.BuildIMemory(0,self.a7.accepted[0])
		self.m2.BuildMemory(0,self.a3.accepted[0])
		self.a3.BuildMemory(0,self.m4.accepted[0])
		self.m4.BuildMemory(0,self.a5.accepted[0])
		self.a5.BuildIMemory(0,self.m6.accepted[0])
		self.m6.BuildMemory(0,self.a7.accepted[1])
		self.a0.BuildIMemory(0,self.m2.accepted[0])
		self.a5.BuildIMemory(0,self.m2.accepted[1])
		self.a7.BuildIMemory(0,self.a3.accepted[1])

		self.mem_res = Group(0, registers, (self.a0.memcare[0], self.m1.memcare[0], self.m2.memcare[0], self.a3.memcare[0], self.m4.memcare[0], self.a5.memcare[0], self.m6.memcare[0], self.a7.memcare[0]))
		self.TR.PruneT(self.mem_res.BuildActive(),(0,1))


bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()
bm.BuildGroups()
bm.TR.Info()
bm.BuildMemory()
bm.TR.Info()
bm.pin = bm.a5
bm.tagdepth = 8
#bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()


print os.times()
