#!/usr/bin/python -u

## This benchmark is used to produce table 6.2 in the ABSS dissertation
import sys
import os
from malib import *

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

bus1 = int(sys.argv[2])
bus2 = int(sys.argv[3])
registers = int(sys.argv[4])
ioports = int(sys.argv[5])
ipblocks = int(sys.argv[6])
alus = int(sys.argv[7])

print os.times()


class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.io0 = COp1(self,1)
		self.a1 = COp1(self,0)
		self.a2 = COp1(self,0)
		self.a3 = COp1(self,1)
		self.a4 = COp1(self,0)
		self.a5 = COp1(self,0)
		self.ma6 = COp3pma(self,0)
		self.a7 = COp1(self,0)
		self.a8 = COp1(self,0)
		self.a9 = COp1(self,1)
		self.a10 = COp1(self,0)
		self.ma11 = COp3pma(self,0)
		self.a12 = COp1(self,0)
		self.a13 = COp1(self,0)
		self.ma14 = COp3pma(self,0)
		self.a15 = COp1(self,0)
		self.ma16 = COp3pma(self,1)
		self.ma17 = COp3pma(self,0)
		self.ma18 = COp3pma(self,0)
		self.ma19 = COp3pma(self,0)
		self.a20 = COp1(self,0)
		self.a21 = COp1(self,0)
		self.a22 = COp1(self,0)
		self.ma23 = COp3pma(self,0)
		self.a24 = COp1(self,0)
		self.a25 = COp1(self,1)
		self.ma26 = COp3pma(self,0)
		self.a27 = COp1(self,1)

		self.outtags = [self.a8, self.a15, self.ma17, self.ma18, self.a24, self.a27, ]

                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		IEnable(set,self.ma23.known[0],self.ma23.required[1])
		IEnable(set,self.ma26.known[0],self.ma26.required[1])
		Enable(set,self.io0.known[0],self.a1.required[0])
		Enable(set,self.a1.known[0],self.a2.required[0])
		Enable(set,self.a3.known[0],self.a4.required[0])
		Enable(set,self.ma6.known[0],self.a7.required[1])
		Enable(set,self.a7.known[0],self.a8.required[0])
		Enable(set,self.a10.known[0],self.ma11.required[0])
		Enable(set,self.a12.known[0],self.ma11.required[1])
		Enable(set,self.a12.known[0],self.a13.required[0])
		Enable(set,self.ma16.known[0],self.a15.required[0])
		Enable(set,self.ma14.known[0],self.a15.required[1])
		Enable(set,self.ma19.known[0],self.ma18.required[1])
		Enable(set,self.ma19.known[0],self.a20.required[1])
		IEnable(set,self.ma23.known[0],self.a22.required[1])
		Enable(set,self.a22.known[0],self.ma23.required[0])
		Enable(set,self.ma23.known[0],self.a24.required[0])
		IEnable(set,self.ma26.known[0],self.a25.required[1])
		Enable(set,self.a25.known[0],self.ma26.required[0])
		Enable(set,self.ma26.known[0],self.a27.required[1])
		Enable(set,self.a1.known[0],self.a3.required[0])
		Enable(set,self.ma6.known[0],self.a4.required[1])
		Enable(set,self.a3.known[0],self.a5.required[0])
		Enable(set,self.a12.known[0],self.a10.required[1])
		Enable(set,self.ma11.known[0],self.a13.required[1])
		Enable(set,self.ma19.known[0],self.ma17.required[1])
		IEnable(set,self.ma17.known[0],self.ma19.required[1])
		Enable(set,self.ma19.known[0],self.a21.required[0])
		Enable(set,self.a20.known[0],self.a22.required[0])
		Enable(set,self.a22.known[0],self.a24.required[1])
		Enable(set,self.a25.known[0],self.a27.required[0])
		IEnable(set,self.a8.known[0],self.a5.required[1])
		Enable(set,self.a3.known[0],self.ma6.required[1])
		Enable(set,self.a10.known[0],self.a7.required[0])
		Enable(set,self.ma11.known[0],self.a8.required[1])
		Enable(set,self.ma6.known[0],self.a9.required[1])
		Enable(set,self.a21.known[0],self.ma18.required[0])
		Enable(set,self.a10.known[0],self.ma6.required[0])
		Enable(set,self.a21.known[0],self.ma17.required[0])
		IEnable(set,self.ma17.known[0],self.a21.required[1])
		Enable(set,self.ma14.known[0],self.a9.required[0])
		Enable(set,self.a5.known[0],self.a10.required[0])
		IEnable(set,self.ma17.known[0],self.a12.required[1])
		Enable(set,self.a13.known[0],self.ma19.required[0])
		Enable(set,self.ma11.known[0],self.a20.required[0])
		Enable(set,self.a4.known[0],self.ma14.required[0])
		Enable(set,self.ma14.known[0],self.a2.required[1])
		IEnable(set,self.a24.known[0],self.a12.required[0])
		Enable(set,self.a1.known[0],self.ma14.required[1])
		IEnable(set,self.a15.known[0],self.a1.required[1])
		Enable(set,self.a2.known[0],self.ma16.required[0])
		Enable(set,self.io0.known[0],self.ma16.required[1])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Enable(set,self.a9.known[0],self.a25.required[0])
		IEnable(set,self.a27.known[0],self.a3.required[1])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()

		set = []

		ICapacity(set,self.ma23.known[0],self.ma23.accepted[1])
		ICapacity(set,self.ma26.known[0],self.ma26.accepted[1])
		Capacity(set,self.io0.known[0],self.a1.accepted[0])
		Capacity(set,self.a1.known[0],self.a2.accepted[0])
		Capacity(set,self.a3.known[0],self.a4.accepted[0])
		Capacity(set,self.ma6.known[0],self.a7.accepted[1])
		Capacity(set,self.a7.known[0],self.a8.accepted[0])
		Capacity(set,self.a10.known[0],self.ma11.accepted[0])
		Capacity(set,self.a12.known[0],self.ma11.accepted[1])
		Capacity(set,self.a12.known[0],self.a13.accepted[0])
		Capacity(set,self.ma16.known[0],self.a15.accepted[0])
		Capacity(set,self.ma14.known[0],self.a15.accepted[1])
		Capacity(set,self.ma19.known[0],self.ma18.accepted[1])
		Capacity(set,self.ma19.known[0],self.a20.accepted[1])
		ICapacity(set,self.ma23.known[0],self.a22.accepted[1])
		Capacity(set,self.a22.known[0],self.ma23.accepted[0])
		Capacity(set,self.ma23.known[0],self.a24.accepted[0])
		ICapacity(set,self.ma26.known[0],self.a25.accepted[1])
		Capacity(set,self.a25.known[0],self.ma26.accepted[0])
		Capacity(set,self.ma26.known[0],self.a27.accepted[1])
		Capacity(set,self.a1.known[0],self.a3.accepted[0])
		Capacity(set,self.ma6.known[0],self.a4.accepted[1])
		Capacity(set,self.a3.known[0],self.a5.accepted[0])
		Capacity(set,self.a12.known[0],self.a10.accepted[1])
		Capacity(set,self.ma11.known[0],self.a13.accepted[1])
		Capacity(set,self.ma19.known[0],self.ma17.accepted[1])
		ICapacity(set,self.ma17.known[0],self.ma19.accepted[1])
		Capacity(set,self.ma19.known[0],self.a21.accepted[0])
		Capacity(set,self.a20.known[0],self.a22.accepted[0])
		Capacity(set,self.a22.known[0],self.a24.accepted[1])
		Capacity(set,self.a25.known[0],self.a27.accepted[0])
		ICapacity(set,self.a8.known[0],self.a5.accepted[1])
		Capacity(set,self.a3.known[0],self.ma6.accepted[1])
		Capacity(set,self.a10.known[0],self.a7.accepted[0])
		Capacity(set,self.ma11.known[0],self.a8.accepted[1])
		Capacity(set,self.ma6.known[0],self.a9.accepted[1])
		Capacity(set,self.a21.known[0],self.ma18.accepted[0])
		Capacity(set,self.a10.known[0],self.ma6.accepted[0])
		Capacity(set,self.a21.known[0],self.ma17.accepted[0])
		ICapacity(set,self.ma17.known[0],self.a21.accepted[1])
		Capacity(set,self.ma14.known[0],self.a9.accepted[0])
		Capacity(set,self.a5.known[0],self.a10.accepted[0])
		ICapacity(set,self.ma17.known[0],self.a12.accepted[1])
		Capacity(set,self.a13.known[0],self.ma19.accepted[0])
		Capacity(set,self.ma11.known[0],self.a20.accepted[0])
		Capacity(set,self.a4.known[0],self.ma14.accepted[0])
		Capacity(set,self.ma14.known[0],self.a2.accepted[1])
		ICapacity(set,self.a24.known[0],self.a12.accepted[0])
		Capacity(set,self.a1.known[0],self.ma14.accepted[1])
		ICapacity(set,self.a15.known[0],self.a1.accepted[1])
		Capacity(set,self.a2.known[0],self.ma16.accepted[0])
		Capacity(set,self.io0.known[0],self.ma16.accepted[1])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Capacity(set,self.a9.known[0],self.a25.accepted[0])
		ICapacity(set,self.a27.known[0],self.a3.accepted[1])


		vec = List2Vec(set)
		self.TR[1].rel = self.TR[1].rel & vec.And()


	def BuildGroups(self):

		alu_list = [self.a1.busy[0], self.a2.busy[0], self.a3.busy[0], self.a4.busy[0], self.a5.busy[0], self.ma6.busy[1], self.a7.busy[0], self.a8.busy[0], self.a9.busy[0], self.a10.busy[0], self.ma11.busy[1], self.a12.busy[0], self.a13.busy[0], self.ma14.busy[1], self.a15.busy[0], self.ma16.busy[1], self.ma17.busy[1], self.ma18.busy[1], self.ma19.busy[1], self.a20.busy[0], self.a21.busy[0], self.a22.busy[0], self.ma23.busy[1], self.a24.busy[0], self.a25.busy[0], self.ma26.busy[1], self.a27.busy[0] ]
		self.alu_res = Group(0, (ipblocks+alus), alu_list)
		self.TR.PruneT(self.alu_res.BuildActive(),(0,1))

		mult_list = [ self.ma6.busy[0], self.ma11.busy[0], self.ma14.busy[0], self.ma16.busy[0], self.ma17.busy[0], self.ma18.busy[0], self.ma19.busy[0], self.ma23.busy[0], self.ma26.busy[0] ]
		self.mult_res = Group(0, ipblocks, mult_list)
		self.TR.PruneT(self.mult_res.BuildActive(),(0,1))

		fromreg_list = [ (self.a1.required[0], self.ma16.required[1], ), (self.a2.required[0], self.a3.required[0], self.ma14.required[1], ), (self.ma16.required[0], ), (self.a4.required[0], self.a5.required[0], self.ma6.required[1], ), (self.ma14.required[0], ), (self.a10.required[0], ), (self.a4.required[1], self.a7.required[1], self.a9.required[1], ), (self.a8.required[0], ), (self.a5.required[1], ), (self.a25.required[0], ), (self.ma6.required[0], self.a7.required[0], self.ma11.required[0], ), (self.a8.required[1], self.a13.required[1], self.a20.required[0], ), (self.a10.required[1], self.ma11.required[1], self.a13.required[0], ), (self.ma19.required[0], ), (self.a2.required[1], self.a9.required[0], self.a15.required[1], ), (self.a1.required[1], ), (self.a15.required[0], ), (self.a12.required[1], self.ma19.required[1], self.a21.required[1], ), (self.ma17.required[1], self.ma18.required[1], self.a20.required[1], self.a21.required[0], ), (self.a22.required[0], ), (self.ma17.required[0], self.ma18.required[0], ), (self.ma23.required[0], self.a24.required[1], ), (self.a22.required[1], self.ma23.required[1], self.a24.required[0], ), (self.a12.required[0], ), (self.ma26.required[0], self.a27.required[0], ), (self.a25.required[1], self.ma26.required[1], self.a27.required[1], ), (self.a3.required[1], ) ]
		self.fromreg_res = Group(0, bus1, fromreg_list )
		self.TR.PruneT(self.fromreg_res.BuildActiveSetOR(),(0,1))

		toreg_list = [ self.io0.produced[0], self.a1.produced[0], self.a2.produced[0], self.a3.produced[0], self.a4.produced[0], self.a5.produced[0], self.ma6.produced[0], self.a7.produced[0], self.a8.produced[0], self.a9.produced[0], self.a10.produced[0], self.ma11.produced[0], self.a12.produced[0], self.a13.produced[0], self.ma14.produced[0], self.a15.produced[0], self.ma16.produced[0], self.ma17.produced[0], self.ma18.produced[0], self.ma19.produced[0], self.a20.produced[0], self.a21.produced[0], self.a22.produced[0], self.ma23.produced[0], self.a24.produced[0], self.a25.produced[0], self.ma26.produced[0], self.a27.produced[0] ]
		self.toreg_res = Group(0, bus2, toreg_list )
		self.TR.PruneT(self.toreg_res.BuildActive(),(0,1))

                ## inbus1 and inbus2 limit the sharing of adds between the IP block and the alu
		inbus1_list = [ self.a1.required[0], self.a2.required[0], self.a3.required[0], self.a4.required[0], self.a5.required[0], self.ma6.required[0], self.a7.required[0], self.a8.required[0], self.a9.required[0], self.a10.required[0], self.ma11.required[0], self.a12.required[0], self.a13.required[0], self.ma14.required[0], self.a15.required[0], self.ma16.required[0], self.ma17.required[0], self.ma18.required[0], self.ma19.required[0], self.a20.required[0], self.a21.required[0], self.a22.required[0], self.ma23.required[0], self.a24.required[0], self.a25.required[0], self.ma26.required[0], self.a27.required[0] ]
		self.inbus1_res = Group(0, (ipblocks+alus), inbus1_list)
		self.TR.PruneT(self.inbus1_res.BuildActive(),(0,1))

		inbus2_list = [ self.a1.required[1], self.a2.required[1], self.a3.required[1], self.a4.required[1], self.a5.required[1], self.ma6.required[1], self.a7.required[1], self.a8.required[1], self.a9.required[1], self.a10.required[1], self.ma11.required[1], self.a12.required[1], self.a13.required[1], self.ma14.required[1], self.a15.required[1], self.ma16.required[1], self.ma17.required[1], self.ma18.required[1], self.ma19.required[1], self.a20.required[1], self.a21.required[1], self.a22.required[1], self.ma23.required[1], self.a24.required[1], self.a25.required[1], self.ma26.required[1], self.a27.required[1] ]
		self.inbus2_res = Group(0, (ipblocks+alus), inbus2_list)
		self.TR.PruneT(self.inbus2_res.BuildActive(),(0,1))

		ioport_list = [ self.io0.produced[0], self.ma18.produced[0] ]
		self.ioport_res = Group(0, ioports, ioport_list )
		self.TR.PruneT(self.ioport_res.BuildActive(),(0,1))

	def BuildMemory(self):
		self.ma23.BuildIMemory(0,self.ma23.accepted[1])
		self.ma26.BuildIMemory(0,self.ma26.accepted[1])
		self.io0.BuildMemory(0,self.a1.accepted[0])
		self.a1.BuildMemory(0,self.a2.accepted[0])
		self.a3.BuildMemory(0,self.a4.accepted[0])
		self.ma6.BuildMemory(0,self.a7.accepted[1])
		self.a7.BuildMemory(0,self.a8.accepted[0])
		self.a10.BuildMemory(0,self.ma11.accepted[0])
		self.a12.BuildMemory(0,self.ma11.accepted[1])
		self.a12.BuildMemory(0,self.a13.accepted[0])
		self.ma16.BuildMemory(0,self.a15.accepted[0])
		self.ma14.BuildMemory(0,self.a15.accepted[1])
		self.ma19.BuildMemory(0,self.ma18.accepted[1])
		self.ma19.BuildMemory(0,self.a20.accepted[1])
		self.ma23.BuildIMemory(0,self.a22.accepted[1])
		self.a22.BuildMemory(0,self.ma23.accepted[0])
		self.ma23.BuildMemory(0,self.a24.accepted[0])
		self.ma26.BuildIMemory(0,self.a25.accepted[1])
		self.a25.BuildMemory(0,self.ma26.accepted[0])
		self.ma26.BuildMemory(0,self.a27.accepted[1])
		self.a1.BuildMemory(0,self.a3.accepted[0])
		self.ma6.BuildMemory(0,self.a4.accepted[1])
		self.a3.BuildMemory(0,self.a5.accepted[0])
		self.a12.BuildMemory(0,self.a10.accepted[1])
		self.ma11.BuildMemory(0,self.a13.accepted[1])
		self.ma19.BuildMemory(0,self.ma17.accepted[1])
		self.ma17.BuildIMemory(0,self.ma19.accepted[1])
		self.ma19.BuildMemory(0,self.a21.accepted[0])
		self.a20.BuildMemory(0,self.a22.accepted[0])
		self.a22.BuildMemory(0,self.a24.accepted[1])
		self.a25.BuildMemory(0,self.a27.accepted[0])
		self.a8.BuildIMemory(0,self.a5.accepted[1])
		self.a3.BuildMemory(0,self.ma6.accepted[1])
		self.a10.BuildMemory(0,self.a7.accepted[0])
		self.ma11.BuildMemory(0,self.a8.accepted[1])
		self.ma6.BuildMemory(0,self.a9.accepted[1])
		self.a21.BuildMemory(0,self.ma18.accepted[0])
		self.a10.BuildMemory(0,self.ma6.accepted[0])
		self.a21.BuildMemory(0,self.ma17.accepted[0])
		self.ma17.BuildIMemory(0,self.a21.accepted[1])
		self.ma14.BuildMemory(0,self.a9.accepted[0])
		self.a5.BuildMemory(0,self.a10.accepted[0])
		self.ma17.BuildIMemory(0,self.a12.accepted[1])
		self.a13.BuildMemory(0,self.ma19.accepted[0])
		self.ma11.BuildMemory(0,self.a20.accepted[0])
		self.a4.BuildMemory(0,self.ma14.accepted[0])
		self.ma14.BuildMemory(0,self.a2.accepted[1])
		self.a24.BuildIMemory(0,self.a12.accepted[0])
		self.a1.BuildMemory(0,self.ma14.accepted[1])
		self.a15.BuildIMemory(0,self.a1.accepted[1])
		self.a2.BuildMemory(0,self.ma16.accepted[0])
		self.io0.BuildMemory(0,self.ma16.accepted[1])
		self.a9.BuildMemory(0,self.a25.accepted[0])
		self.a27.BuildIMemory(0,self.a3.accepted[1])

		mem_list = [ self.io0.memcare[0], self.a1.memcare[0], self.a2.memcare[0], self.a3.memcare[0], self.a4.memcare[0], self.a5.memcare[0], self.ma6.memcare[0], self.a7.memcare[0], self.a8.memcare[0], self.a9.memcare[0], self.a10.memcare[0], self.ma11.memcare[0], self.a12.memcare[0], self.a13.memcare[0], self.ma14.memcare[0], self.a15.memcare[0], self.ma16.memcare[0], self.ma17.memcare[0], self.ma18.memcare[0], self.ma19.memcare[0], self.a20.memcare[0], self.a21.memcare[0], self.a22.memcare[0], self.ma23.memcare[0], self.a24.memcare[0], self.a25.memcare[0], self.ma26.memcare[0], self.a27.memcare[0] ]
		self.mem_res = Group(0, registers, mem_list)
		self.TR.PruneT(self.mem_res.BuildActive(),(0,1))

bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()
bm.BuildGroups()
bm.TR.Info()
bm.BuildMemory()
bm.TR.Info()
bm.pin = bm.a10
bm.tagdepth = 10
#bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()


print os.times()
