#!/usr/bin/python -u
import sys
import os
from malib import *

outname = sys.argv[1]

if not outname == "term":
        print "Output to",outname
        sys.stdout = open(outname,"w")

alus = int(sys.argv[2])
mults = int(sys.argv[3])
registers = int(sys.argv[4])

print os.times()

class Top(Model):

	def __init__(self,parent):

		Model.__init__(self,parent)
		self.submodels = []

		self.a1 = COp1(self,0)
		self.m9 = COp2p(self,0)
		self.a17 = COp1(self,0)
		self.m10 = COp2p(self,0)
		self.a2 = COp1(self,0)
		self.a18 = COp1(self,0)
		self.m11 = COp2p(self,0)
		self.a3 = COp1(self,0)
		self.a19 = COp1(self,0)
		self.m12 = COp2p(self,0)
		self.a4 = COp1(self,0)
		self.a20 = COp1(self,0)
		self.m13 = COp2p(self,0)
		self.a5 = COp1(self,0)
		self.a21 = COp1(self,0)
		self.m14 = COp2p(self,0)
		self.a6 = COp1(self,0)
		self.a22 = COp1(self,0)
		self.m15 = COp2p(self,0)
		self.a7 = COp1(self,0)
		self.a23 = COp1(self,0)
		self.m16 = COp2p(self,0)
		self.a8 = COp1(self,0)

		self.outtags = [self.a23, ]

                self.AddNames()

	def BuildRelation(self):
		Model.BuildCompositeTR(self)
		set = []

		Enable(set,self.a1.known[0],self.m9.required[0])
		Enable(set,self.a2.known[0],self.m10.required[0])
		Enable(set,self.a3.known[0],self.m11.required[0])
		Enable(set,self.a4.known[0],self.m12.required[0])
		Enable(set,self.a5.known[0],self.m13.required[0])
		Enable(set,self.a6.known[0],self.m14.required[0])
		Enable(set,self.a7.known[0],self.m15.required[0])
		Enable(set,self.a8.known[0],self.m16.required[0])
		Enable(set,self.m9.known[0],self.a17.required[0])
		Enable(set,self.m10.known[0],self.a17.required[1])
		Enable(set,self.m11.known[0],self.a18.required[1])
		Enable(set,self.m12.known[0],self.a19.required[1])
		Enable(set,self.m13.known[0],self.a20.required[1])
		Enable(set,self.m14.known[0],self.a21.required[1])
		Enable(set,self.m15.known[0],self.a22.required[1])
		Enable(set,self.m16.known[0],self.a23.required[1])
		Enable(set,self.a17.known[0],self.a18.required[0])
		Enable(set,self.a18.known[0],self.a19.required[0])
		Enable(set,self.a19.known[0],self.a20.required[0])
		Enable(set,self.a20.known[0],self.a21.required[0])
		Enable(set,self.a21.known[0],self.a22.required[0])
		Enable(set,self.a22.known[0],self.a23.required[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()

		set = []

		Capacity(set,self.a1.known[0],self.m9.accepted[0])
		Capacity(set,self.a2.known[0],self.m10.accepted[0])
		Capacity(set,self.a3.known[0],self.m11.accepted[0])
		Capacity(set,self.a4.known[0],self.m12.accepted[0])
		Capacity(set,self.a5.known[0],self.m13.accepted[0])
		Capacity(set,self.a6.known[0],self.m14.accepted[0])
		Capacity(set,self.a7.known[0],self.m15.accepted[0])
		Capacity(set,self.a8.known[0],self.m16.accepted[0])
		Capacity(set,self.m9.known[0],self.a17.accepted[0])
		Capacity(set,self.m10.known[0],self.a17.accepted[1])
		Capacity(set,self.m11.known[0],self.a18.accepted[1])
		Capacity(set,self.m12.known[0],self.a19.accepted[1])
		Capacity(set,self.m13.known[0],self.a20.accepted[1])
		Capacity(set,self.m14.known[0],self.a21.accepted[1])
		Capacity(set,self.m15.known[0],self.a22.accepted[1])
		Capacity(set,self.m16.known[0],self.a23.accepted[1])
		Capacity(set,self.a17.known[0],self.a18.accepted[0])
		Capacity(set,self.a18.known[0],self.a19.accepted[0])
		Capacity(set,self.a19.known[0],self.a20.accepted[0])
		Capacity(set,self.a20.known[0],self.a21.accepted[0])
		Capacity(set,self.a21.known[0],self.a22.accepted[0])
		Capacity(set,self.a22.known[0],self.a23.accepted[0])


		vec = List2Vec(set)
		self.TR[0].rel = self.TR[0].rel & vec.And()


	def BuildGroups(self):

		self.alu_res = Group(0, alus, (self.a1.busy[0], self.a2.busy[0], self.a3.busy[0], self.a4.busy[0], self.a5.busy[0], self.a6.busy[0], self.a7.busy[0], self.a8.busy[0], self.a17.busy[0], self.a18.busy[0], self.a19.busy[0], self.a20.busy[0], self.a21.busy[0], self.a22.busy[0], self.a23.busy[0]))
		self.TR.PruneT(self.alu_res.BuildActive(),(0,1))

		self.mult_res = Group(0, mults, (self.m9.busy[0], self.m10.busy[0], self.m11.busy[0], self.m12.busy[0], self.m13.busy[0], self.m14.busy[0], self.m15.busy[0], self.m16.busy[0]))
		self.TR.PruneT(self.mult_res.BuildActive(),(0,1))

	def BuildMemory(self):
		self.a1.BuildMemory(0,self.m9.accepted[0])
		self.a2.BuildMemory(0,self.m10.accepted[0])
		self.a3.BuildMemory(0,self.m11.accepted[0])
		self.a4.BuildMemory(0,self.m12.accepted[0])
		self.a5.BuildMemory(0,self.m13.accepted[0])
		self.a6.BuildMemory(0,self.m14.accepted[0])
		self.a7.BuildMemory(0,self.m15.accepted[0])
		self.a8.BuildMemory(0,self.m16.accepted[0])
		self.m9.BuildMemory(0,self.a17.accepted[0])
		self.m10.BuildMemory(0,self.a17.accepted[1])
		self.m11.BuildMemory(0,self.a18.accepted[1])
		self.m12.BuildMemory(0,self.a19.accepted[1])
		self.m13.BuildMemory(0,self.a20.accepted[1])
		self.m14.BuildMemory(0,self.a21.accepted[1])
		self.m15.BuildMemory(0,self.a22.accepted[1])
		self.m16.BuildMemory(0,self.a23.accepted[1])
		self.a17.BuildMemory(0,self.a18.accepted[0])
		self.a18.BuildMemory(0,self.a19.accepted[0])
		self.a19.BuildMemory(0,self.a20.accepted[0])
		self.a20.BuildMemory(0,self.a21.accepted[0])
		self.a21.BuildMemory(0,self.a22.accepted[0])
		self.a22.BuildMemory(0,self.a23.accepted[0])


		self.mem_res = Group(0, registers, (self.a1.memcare[0], self.a2.memcare[0], self.a3.memcare[0], self.a4.memcare[0], self.a5.memcare[0], self.a6.memcare[0], self.a7.memcare[0], self.a8.memcare[0], self.m9.memcare[0], self.m10.memcare[0], self.m11.memcare[0], self.m12.memcare[0], self.m13.memcare[0], self.m14.memcare[0], self.m15.memcare[0], self.m16.memcare[0], self.a17.memcare[0], self.a18.memcare[0], self.a19.memcare[0], self.a20.memcare[0], self.a21.memcare[0], self.a22.memcare[0], self.a23.memcare[0]))
		self.TR.PruneT(self.mem_res.BuildActive(),(0,1))


bm = Top(0)
bm.BuildCompositeState(0)
bm.BuildRelation()
bm.TR.Info()
bm.TR.SetVarMap()
bm.BuildVectors((0,0),(0,1))
bm.TR.Info()
bm.TR.ReachabilityPrune(bm.taskstart[0],(0,1))
bm.TR.Collapse()
bm.TR.Info()
bm.BuildGroups()
bm.TR.Info()
bm.BuildMemory()
bm.TR.Info()
bm.pin = bm.a23
bm.tagdepth = 4
#bm.Reorder()
result = bm.DFSchedule()
result.Trace()
result.PrintTrace()


print os.times()
